<script lang="ts">
	import { createEventDispatcher, onMount } from 'svelte'

	interface Props {
		text?: string;
		items?: string[];
	}

	let { text = 'Click to open', items = $bindable(['one', 'two', 'three']) }: Props = $props();

	let activeElement: Element | null
	let details: HTMLDetailsElement = $state()
	let hasFocus: boolean = $state(false)

	const dispatch = createEventDispatcher()

	function onClick(e: MouseEvent & { currentTarget: EventTarget & HTMLLabelElement }) {
		selecttedItem(e.currentTarget.innerText)
	}

	function onKeyPress(e: KeyboardEvent & { currentTarget: EventTarget & HTMLLabelElement }) {
		selecttedItem(e.currentTarget.innerText)
	}

	function onDocumentKeyUp(ev: KeyboardEvent) {
		activeElement = document.activeElement
		if (!activeElement) return
		hasFocus = isElementInChain(details, activeElement)
		if (hasFocus) {
			details?.setAttribute('open', 'true')
		} else {
			details?.removeAttribute('open')
		}
	}

	function isElementInChain(parent: Element, element: Element): boolean {
		if (element.parentElement === parent) return true
		if (!element?.parentElement) return false
		return isElementInChain(parent, element.parentElement)
	}

	onMount(() => {
		document.addEventListener('keyup', onDocumentKeyUp)
	})

	function selecttedItem(text: string) {
		items = items.filter((o) => o !== text)
		dispatch('add', { item: text })
		if (!items.length) {
			details.open = false
		}
	}
</script>

<details id="details" bind:this={details}>
	<summary class:focus={hasFocus}>{text}</summary>
	<ul>
		{#each [...new Set(items)] as item (item)}
			<li>
				<label role="button" tabindex="0" for={item} onclick={onClick} onkeypress={onKeyPress}>{item}</label>
			</li>
		{/each}
	</ul>
</details>

<style>
	details {
		position: relative;

		margin-right: 1rem;
	}

	details[open] {
		z-index: 1;
	}

	summary:focus {
		color: #ffffffdd;
	}

	.focus {
		color: #ffffffdd;
	}

	summary {
		padding: 1rem;
		cursor: pointer;
		border-radius: 5px;
		background-color: transparent;
		list-style: none;
		color: #ffffffaa;
		user-select: none;
		text-align: left;
	}

	summary::-webkit-details-marker {
		display: none;
	}

	details[open] summary:before {
		content: '';
		display: block;
		width: 100vw;
		height: 100vh;
		background: transparent;
		position: fixed;
		top: 0;
		left: 0;
	}

	summary:after {
		content: '';
		display: inline-block;
		float: right;
		color: #ffffffbb;
		width: 0.5rem;
		height: 0.5rem;
		border-bottom: 1px solid currentColor;
		border-left: 1px solid currentColor;
		border-bottom-left-radius: 2px;
		transform: rotate(45deg) translate(50%, 0%);
		transform-origin: center center;
		transition: transform ease-in-out 100ms;
	}

	summary:focus {
		outline: none;
	}

	details[open] summary:after {
		transform: rotate(-45deg) translate(0%, 0%);
	}

	ul {
		width: 100%;
		background: #111;
		position: absolute;
		top: calc(100% + 0.5rem);
		left: 0;
		padding: 1rem;
		margin: 0;
		box-sizing: border-box;
		border-radius: 5px;
		max-height: 200px;
		overflow-y: auto;
		list-style: none;
		color: #ffffffaa;
	}

	li {
		margin: 0;
		padding: 1rem 0;
		border-bottom: 1px solid #222;
	}

	li:first-child {
		padding-top: 0;
	}

	li:last-child {
		padding-bottom: 0;
		border-bottom: none;
	}

	label {
		width: 100%;
		display: flex;
		cursor: pointer;
		justify-content: space-between;
	}

	label:hover {
		color: #ffffffdd;
	}
</style>
